> For the complete documentation index, see [llms.txt](https://docs.archera.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.archera.ai/api-reference/public-api/savings-estimate.md).

# Savings Estimate

API for estimating savings from uploaded billing files

## List an organization's savings estimates

> Returns completed and errored savings estimates for the organization, newest first. Queued/processing estimates are omitted since they have nothing to show yet.

```json
{"openapi":"3.1.0","info":{"title":"Archera.ai API","version":"v1.0.0"},"tags":[{"name":"Savings Estimate","description":"API for estimating savings from uploaded billing files"}],"paths":{"/v1/org/{org_id}/savings-estimate":{"get":{"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/SavingsEstimateSummary"}}}},"headers":{"X-Pagination":{"$ref":"#/components/headers/PAGINATION"}}},"400":{"description":"Bad request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"405":{"description":"Method not allowed","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"409":{"description":"Conflict","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"422":{"$ref":"#/components/responses/UNPROCESSABLE_CONTENT"},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"default":{"$ref":"#/components/responses/DEFAULT_ERROR"}},"parameters":[{"in":"query","name":"page","schema":{"type":"integer","default":1,"minimum":1},"required":false},{"in":"query","name":"page_size","schema":{"type":"integer","default":20,"minimum":1,"maximum":100},"required":false}],"tags":["Savings Estimate"],"summary":"List an organization's savings estimates","description":"Returns completed and errored savings estimates for the organization, newest first. Queued/processing estimates are omitted since they have nothing to show yet."}}},"components":{"schemas":{"SavingsEstimateSummary":{"type":"object","properties":{"id":{"type":"string","format":"uuid","readOnly":true},"upload_id":{"type":"string","format":"uuid","readOnly":true},"status":{"readOnly":true,"enum":["queued","processing","complete","error"]},"created_at":{"type":"string","format":"date-time","readOnly":true},"filename":{"type":"string","readOnly":true},"provider":{"readOnly":true,"type":["string","null"],"enum":["aws","azure","gcp",null]},"period_start":{"type":["string","null"],"format":"date","readOnly":true},"period_end":{"type":["string","null"],"format":"date","readOnly":true},"currency":{"type":["string","null"],"readOnly":true},"extraction_status":{"readOnly":true,"enum":["complete","partial","unverified",null]},"total_savings_estimate":{"readOnly":true,"anyOf":[{"$ref":"#/components/schemas/ValueRange"},{"type":"null"}]}},"required":["created_at","currency","extraction_status","filename","id","period_end","period_start","provider","status","total_savings_estimate","upload_id"],"additionalProperties":false},"ValueRange":{"type":"object","properties":{"estimate":{"type":"number"},"lower_bound":{"type":["number","null"]},"upper_bound":{"type":["number","null"]}},"required":["estimate","lower_bound","upper_bound"],"additionalProperties":false},"PaginationMetadata":{"type":"object","properties":{"total":{"type":"integer","description":"Total number of items."},"total_pages":{"type":"integer","description":"Total number of pages."},"first_page":{"type":"integer","description":"First available page number."},"last_page":{"type":"integer","description":"Last available page number."},"page":{"type":"integer","description":"Current page number."},"previous_page":{"type":"integer","description":"Previous page number."},"next_page":{"type":"integer","description":"Next page number."}},"additionalProperties":false},"ApiErrorResponse":{"type":"object","properties":{"error":{"type":"string"},"message":{"type":"string"},"errors":{"type":"object","additionalProperties":{}},"detail":{},"code":{"type":["string","null"]},"status":{"type":"string"},"url":{"type":["string","null"]},"timestamp":{"type":"string"},"type":{"type":"string"}},"required":["error","errors","message","timestamp","type"]},"Error":{"type":"object","properties":{"code":{"type":"integer","description":"Error code"},"status":{"type":"string","description":"Error name"},"message":{"type":"string"},"errors":{"type":"object","additionalProperties":{}},"error":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"required":["error","errors","message","timestamp","type"],"additionalProperties":false}},"headers":{"PAGINATION":{"description":"Pagination metadata","schema":{"$ref":"#/components/schemas/PaginationMetadata"}}},"responses":{"UNPROCESSABLE_CONTENT":{"description":"Unprocessable Content","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"DEFAULT_ERROR":{"description":"Default error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}
```

## Estimate savings for an uploaded billing file

> Parses supported billing formats synchronously (200), and queues LLM fallback otherwise (202). Poll queued estimates until status is complete or error. If the latest estimate for this upload has not failed, it is returned (200).

```json
{"openapi":"3.1.0","info":{"title":"Archera.ai API","version":"v1.0.0"},"tags":[{"name":"Savings Estimate","description":"API for estimating savings from uploaded billing files"}],"paths":{"/v1/org/{org_id}/savings-estimate":{"post":{"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SavingsEstimate"}}}},"202":{"description":"Accepted","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SavingsEstimate"}}}},"400":{"description":"Bad request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"405":{"description":"Method not allowed","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"409":{"description":"Conflict","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"422":{"$ref":"#/components/responses/UNPROCESSABLE_CONTENT"},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"default":{"$ref":"#/components/responses/DEFAULT_ERROR"}},"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SavingsEstimateRequest"}}}},"tags":["Savings Estimate"],"summary":"Estimate savings for an uploaded billing file","description":"Parses supported billing formats synchronously (200), and queues LLM fallback otherwise (202). Poll queued estimates until status is complete or error. If the latest estimate for this upload has not failed, it is returned (200)."}}},"components":{"schemas":{"SavingsEstimate":{"type":"object","properties":{"id":{"type":"string","format":"uuid","readOnly":true},"status":{"readOnly":true,"enum":["queued","processing","complete","error"]},"error":{"type":["string","null"],"readOnly":true},"upload_id":{"type":"string","format":"uuid","readOnly":true},"result":{"readOnly":true,"anyOf":[{"$ref":"#/components/schemas/SavingsEstimateDetail"},{"type":"null"}]}},"required":["id","status","upload_id"],"additionalProperties":false},"SavingsEstimateDetail":{"type":"object","properties":{"provider":{"type":["string","null"],"enum":["aws","azure","gcp",null]},"source_format":{"type":"string"},"period_start":{"type":["string","null"],"format":"date"},"period_end":{"type":["string","null"],"format":"date"},"account_id":{"type":["string","null"]},"currency":{"type":"string"},"is_projected":{"type":"boolean"},"extraction_status":{"enum":["complete","partial","unverified"]},"line_items":{"type":"array","items":{"$ref":"#/components/schemas/CostLineItem"}},"total_cost":{"readOnly":true,"$ref":"#/components/schemas/ValueRange"},"total_savings_estimate":{"readOnly":true,"$ref":"#/components/schemas/ValueRange"}},"required":["account_id","currency","extraction_status","is_projected","line_items","period_end","period_start","provider","source_format","total_cost","total_savings_estimate"],"additionalProperties":false},"CostLineItem":{"type":"object","properties":{"service":{"type":"string"},"reservable_service":{"type":["string","null"]},"service_code":{"type":["string","null"],"readOnly":true},"resource_type":{"type":["string","null"]},"usage_quantity":{"anyOf":[{"$ref":"#/components/schemas/ValueRange"},{"type":"null"}]},"usage_unit":{"type":["string","null"]},"cost":{"$ref":"#/components/schemas/ValueRange"},"region":{"type":["string","null"]},"spend_type":{"enum":["on_demand","reserved","unreservable","unknown"]},"savings_estimate":{"anyOf":[{"$ref":"#/components/schemas/ValueRange"},{"type":"null"}]}},"required":["cost","region","reservable_service","resource_type","savings_estimate","service","spend_type","usage_quantity","usage_unit"],"additionalProperties":false},"ValueRange":{"type":"object","properties":{"estimate":{"type":"number"},"lower_bound":{"type":["number","null"]},"upper_bound":{"type":["number","null"]}},"required":["estimate","lower_bound","upper_bound"],"additionalProperties":false},"ApiErrorResponse":{"type":"object","properties":{"error":{"type":"string"},"message":{"type":"string"},"errors":{"type":"object","additionalProperties":{}},"detail":{},"code":{"type":["string","null"]},"status":{"type":"string"},"url":{"type":["string","null"]},"timestamp":{"type":"string"},"type":{"type":"string"}},"required":["error","errors","message","timestamp","type"]},"Error":{"type":"object","properties":{"code":{"type":"integer","description":"Error code"},"status":{"type":"string","description":"Error name"},"message":{"type":"string"},"errors":{"type":"object","additionalProperties":{}},"error":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"required":["error","errors","message","timestamp","type"],"additionalProperties":false},"SavingsEstimateRequest":{"type":"object","properties":{"upload_id":{"type":"string","format":"uuid"}},"required":["upload_id"],"additionalProperties":false}},"responses":{"UNPROCESSABLE_CONTENT":{"description":"Unprocessable Content","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"DEFAULT_ERROR":{"description":"Default error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}
```

## Get a savings estimate's status and result

> Returns the queued/processing/complete/error status for a savings estimate. Clients can poll this endpoint until status is complete or error.

```json
{"openapi":"3.1.0","info":{"title":"Archera.ai API","version":"v1.0.0"},"tags":[{"name":"Savings Estimate","description":"API for estimating savings from uploaded billing files"}],"paths":{"/v1/org/{org_id}/savings-estimate/{estimate_id}":{"get":{"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/SavingsEstimate"}}}},"400":{"description":"Bad request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"403":{"description":"Forbidden","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"405":{"description":"Method not allowed","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"409":{"description":"Conflict","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"default":{"$ref":"#/components/responses/DEFAULT_ERROR"}},"tags":["Savings Estimate"],"summary":"Get a savings estimate's status and result","description":"Returns the queued/processing/complete/error status for a savings estimate. Clients can poll this endpoint until status is complete or error."}}},"components":{"schemas":{"SavingsEstimate":{"type":"object","properties":{"id":{"type":"string","format":"uuid","readOnly":true},"status":{"readOnly":true,"enum":["queued","processing","complete","error"]},"error":{"type":["string","null"],"readOnly":true},"upload_id":{"type":"string","format":"uuid","readOnly":true},"result":{"readOnly":true,"anyOf":[{"$ref":"#/components/schemas/SavingsEstimateDetail"},{"type":"null"}]}},"required":["id","status","upload_id"],"additionalProperties":false},"SavingsEstimateDetail":{"type":"object","properties":{"provider":{"type":["string","null"],"enum":["aws","azure","gcp",null]},"source_format":{"type":"string"},"period_start":{"type":["string","null"],"format":"date"},"period_end":{"type":["string","null"],"format":"date"},"account_id":{"type":["string","null"]},"currency":{"type":"string"},"is_projected":{"type":"boolean"},"extraction_status":{"enum":["complete","partial","unverified"]},"line_items":{"type":"array","items":{"$ref":"#/components/schemas/CostLineItem"}},"total_cost":{"readOnly":true,"$ref":"#/components/schemas/ValueRange"},"total_savings_estimate":{"readOnly":true,"$ref":"#/components/schemas/ValueRange"}},"required":["account_id","currency","extraction_status","is_projected","line_items","period_end","period_start","provider","source_format","total_cost","total_savings_estimate"],"additionalProperties":false},"CostLineItem":{"type":"object","properties":{"service":{"type":"string"},"reservable_service":{"type":["string","null"]},"service_code":{"type":["string","null"],"readOnly":true},"resource_type":{"type":["string","null"]},"usage_quantity":{"anyOf":[{"$ref":"#/components/schemas/ValueRange"},{"type":"null"}]},"usage_unit":{"type":["string","null"]},"cost":{"$ref":"#/components/schemas/ValueRange"},"region":{"type":["string","null"]},"spend_type":{"enum":["on_demand","reserved","unreservable","unknown"]},"savings_estimate":{"anyOf":[{"$ref":"#/components/schemas/ValueRange"},{"type":"null"}]}},"required":["cost","region","reservable_service","resource_type","savings_estimate","service","spend_type","usage_quantity","usage_unit"],"additionalProperties":false},"ValueRange":{"type":"object","properties":{"estimate":{"type":"number"},"lower_bound":{"type":["number","null"]},"upper_bound":{"type":["number","null"]}},"required":["estimate","lower_bound","upper_bound"],"additionalProperties":false},"ApiErrorResponse":{"type":"object","properties":{"error":{"type":"string"},"message":{"type":"string"},"errors":{"type":"object","additionalProperties":{}},"detail":{},"code":{"type":["string","null"]},"status":{"type":"string"},"url":{"type":["string","null"]},"timestamp":{"type":"string"},"type":{"type":"string"}},"required":["error","errors","message","timestamp","type"]},"Error":{"type":"object","properties":{"code":{"type":"integer","description":"Error code"},"status":{"type":"string","description":"Error name"},"message":{"type":"string"},"errors":{"type":"object","additionalProperties":{}},"error":{"type":"string"},"timestamp":{"type":"string"},"type":{"type":"string"}},"required":["error","errors","message","timestamp","type"],"additionalProperties":false}},"responses":{"DEFAULT_ERROR":{"description":"Default error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.archera.ai/api-reference/public-api/savings-estimate.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
